## kazmath-48dbc191da47880ea6708b0a7b3c7b69b6352cad.tar.gz

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(kazmath)

option(KAZMATH_BUILD_TESTS "Build kazmath test suite" ON)
option(KAZMATH_BUILD_JNI_WRAPPER "Build JNI wrapper" ON)
option(KAZMATH_BUILD_GL_UTILS "Build gl utils" ON)
option(KAZMATH_BUILD_LUA_WRAPPER "Build Lua wrapper" ON)

IF (KAZMATH_BUILD_TESTS)
    ENABLE_TESTING()
    FIND_PACKAGE(PythonLibs REQUIRED)
ENDIF (KAZMATH_BUILD_TESTS)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
add_definitions(-D_DEFAULT_SOURCE)

SET(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib" CACHE PATH "Installation directory for libraries")

ADD_DEFINITIONS("-Wall -g")
#ADD_DEFINITIONS("-DUSE_DOUBLE_PRECISION")

SET(KAZMATH_HEADERS
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/vec2.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/vec3.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/vec4.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/mat4.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/mat3.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/ray2.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/ray3.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/plane.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/utility.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/quaternion.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/aabb2.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/aabb3.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/kazmath.h
)

SET(GL_UTILS_HEADERS
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/GL/mat4stack.h
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/GL/matrix.h
)

SET(KAZMATH_SOURCES
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/mat4.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/mat3.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/plane.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/vec4.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/quaternion.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/vec2.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/vec3.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/utility.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/aabb2.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/aabb3.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/ray2.c
    ${CMAKE_CURRENT_LIST_DIR}/kazmath/ray3.c
)

IF (KAZMATH_BUILD_GL_UTILS)
    SET(KAZMATH_SOURCES
        ${KAZMATH_SOURCES}
        ${CMAKE_CURRENT_LIST_DIR}/kazmath/GL/mat4stack.c
        ${CMAKE_CURRENT_LIST_DIR}/kazmath/GL/matrix.c
    )
ENDIF (KAZMATH_BUILD_GL_UTILS)

ADD_SUBDIRECTORY(kazmath)

IF (KAZMATH_BUILD_TESTS)
    ADD_SUBDIRECTORY(tests)
ENDIF (KAZMATH_BUILD_TESTS)

IF (KAZMATH_BUILD_JNI_WRAPPER)
    ADD_SUBDIRECTORY(java)
ENDIF (KAZMATH_BUILD_JNI_WRAPPER)

IF (KAZMATH_BUILD_LUA_WRAPPER)
    ADD_SUBDIRECTORY(lua)
ENDIF (KAZMATH_BUILD_LUA_WRAPPER)

SET(CPACK_PACKAGE_DEFAULT_LOCATION "/")
SET(CPACK_GENERATOR "RPM")
set(CPACK_PACKAGE_NAME "kazmath")
set(CPACK_PACKAGE_VENDOR "Kazade")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A simple 3D math library, designed for game development")
set(CPACK_PACKAGE_VERSION "0.5")
set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "5")
set(CPACK_PACKAGE_VERSION_PATCH "0")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "kazmath")

SET(CPACK_RPM_PACKAGE_NAME "kazmath-devel")
SET(CPACK_RPM_PACKAGE_RELEASE 1)
SET(CPACK_RPM_PACKAGE_LICENCE "Simplified BSD")
SET(CPACK_RPM_PACKAGE_GROUP "Development/Libraries")
SET(CPACK_RPM_PACKAGE_DESCRIPTION "
Kazmath is a 3D math library written in C. It's designed to be easy to use and understand.
The library contains math functions for 2D, 3D and 4D vectors. 3x3 and 4x4 matrices, quaternions, planes and axis-aligned boxes")

INCLUDE(CPack)

=== java/CMakeLists.txt ===

FIND_PACKAGE(Java) #Find the java executables

IF(JAVA_FOUND)

FIND_PACKAGE(JNI)

IF(JNI_FOUND)
MESSAGE("Building JNI wrapper")

SET(JKAZMATH_CLASS kazmath/jkazmath.class)
SET(JKAZMATH_HEADER jni/kazmath_jkazmath.h)
SET(JKAZMATH_JAR kazmath.jar)

FILE(GLOB_RECURSE KAZMATH_C_FILES ${CMAKE_SOURCE_DIR}/kazmath/*.c ${CMAKE_CURRENT_SOURCE_DIR}/jni/*.c)

ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${JKAZMATH_CLASS} COMMAND ${Java_JAVAC_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/kazmath/jkazmath.java -d ${CMAKE_CURRENT_BINARY_DIR})
ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${JKAZMATH_HEADER} COMMAND ${Java_JAVAH_EXECUTABLE} -classpath ${CMAKE_CURRENT_BINARY_DIR} -d jni kazmath.jkazmath DEPENDS ${JKAZMATH_CLASS})

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/jni ${JNI_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR}/kazmath)

SET(CMAKE_SHARED_LINKER_FLAGS "-lm -lc")
SET(CMAKE_POSITION_INDEPENDENT_CODE ON) 

ADD_LIBRARY(Jkazmath SHARED ${KAZMATH_C_FILES} ${JKAZMATH_HEADER})
ADD_CUSTOM_COMMAND(TARGET Jkazmath POST_BUILD COMMAND ${Java_JAR_EXECUTABLE} cvf kazmath.jar kazmath)

INSTALL(TARGETS Jkazmath LIBRARY DESTINATION ${INSTALL_LIB_DIR})
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/kazmath.jar DESTINATION ${CMAKE_INSTALL_PREFIX}/share/java)
ELSE(JNI_FOUND)
MESSAGE("Not building JNI wrapper. Couldn't find JNI")
ENDIF(JNI_FOUND)

ENDIF(JAVA_FOUND)

=== kazmath/CMakeLists.txt ===

#ADD_LIBRARY(Kazmath STATIC ${KAZMATH_SRCS})
#INSTALL(TARGETS Kazmath ARCHIVE DESTINATION lib)
FIND_PACKAGE(Threads REQUIRED)

if(BUILD_SHARED_LIBS)
  ADD_LIBRARY(kazmath SHARED ${KAZMATH_SOURCES})
  TARGET_LINK_LIBRARIES(kazmath  ${CMAKE_THREAD_LIBS_INIT})
  SET_TARGET_PROPERTIES(kazmath
                        PROPERTIES
                        VERSION 0.0.1
                        SOVERSION 1)
else()
  ADD_LIBRARY(kazmath STATIC ${KAZMATH_SOURCES})
endif()

SET_TARGET_PROPERTIES(kazmath PROPERTIES COMPILE_FLAGS "--std=c99")

INSTALL(TARGETS kazmath DESTINATION ${INSTALL_LIB_DIR})

#ADD_LIBRARY(KazmathGL STATIC ${GL_UTILS_SRCS})
#INSTALL(TARGETS KazmathGL ARCHIVE DESTINATION lib)

INSTALL(FILES ${KAZMATH_HEADERS} DESTINATION include/kazmath)
IF (KAZMATH_BUILD_GL_UTILS)
    INSTALL(FILES ${GL_UTILS_HEADERS} DESTINATION include/kazmath/GL)
ENDIF (KAZMATH_BUILD_GL_UTILS)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/KAZMATHConfig.cmake DESTINATION ${CMAKE_INSTALL_PREFIX}/share/kazmath)

=== kazmathxx/CMakeLists.txt ===
SET(KAZMATHXX_HEADERS
vec2.h
vec3.h
vec4.h
mat4.h
mat3.h
plane.h
quaternion.h
aabb.h
)

INSTALL(FILES ${KAZMATHXX_HEADERS} DESTINATION include/kazmathxx)

=== lua/CMakeLists.txt ===
MESSAGE("Building lkazmath wrapper")

FILE(GLOB_RECURSE KAZMATH_C_FILES ${CMAKE_SOURCE_DIR}/kazmath/*.c ${CMAKE_CURRENT_SOURCE_DIR}/*.c)

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/kazmath)

FIND_PACKAGE(Lua51)

IF(LUA51_FOUND)
    SET(CMAKE_POSITION_INDEPENDENT_CODE ON)

    LIST(REMOVE_ITEM KAZMATH_C_FILES ${CMAKE_SOURCE_DIR}/kazmath/GL/mat4stack.c)
    LIST(REMOVE_ITEM KAZMATH_C_FILES ${CMAKE_SOURCE_DIR}/kazmath/GL/matrix.c)

    ADD_LIBRARY(lkazmath SHARED ${KAZMATH_C_FILES})
    TARGET_LINK_LIBRARIES(lkazmath ${LUA_LIBRARIES})
    include_directories(${LUA_INCLUDE_DIR})

    INSTALL(TARGETS lkazmath LIBRARY DESTINATION ${INSTALL_LIB_DIR})
ELSE()
    MESSAGE("Unable to build Lua bindings as lua was not installed on the system")
ENDIF()

=== tests/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/include )

FILE(GLOB_RECURSE TEST_FILES *.h)
FILE(GLOB_RECURSE TEST_SOURCES *.cpp)

SET(KAZTEST_EXECUTABLE ${CMAKE_SOURCE_DIR}/bin/kaztest_gen)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
    COMMAND ${KAZTEST_EXECUTABLE} --output ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp ${TEST_FILES}
    DEPENDS ${TEST_FILES} ${KAZTEST_EXECUTABLE}
)

ADD_EXECUTABLE(kazmath_tests ${TEST_FILES} ${TEST_SOURCES} ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp)
SET_TARGET_PROPERTIES(kazmath_tests PROPERTIES COMPILE_FLAGS "-std=c++11")

ADD_TEST(kazmath_suite kazmath_tests)

TARGET_LINK_LIBRARIES(
    kazmath_tests
    kazmath
)

=== debian/changelog ===
libkazmath-dev (1.1.0) maverick; urgency=low

  * Numerous bugfixes

 -- Luke Benstead (Kazade) <kazade@gmail.com>  Sat, 8 Jan 2011 08:59:00 +1100

libkazmath-dev (1.0.0) jaunty; urgency=low

  * debian/control:
    - initial packaged version

 -- Luke Benstead (Kazade) <kazade@gmail.com>  Sat, 04 Apr 2009 13:42:42 +1100

=== debian/control ===
Source: libkazmath-dev
Priority: optional
Section: libs
Maintainer: Luke Benstead (Kazade) <kazade@gmail.com>
Build-Depends: dpkg (>= 1.13.2), debhelper (>= 4.0), cmake (>= 2), libunittest++-dev
Standards-Version: 3.9.1

Package: libkazmath-dev
Architecture: any
Section: libdevel
Description: Kazmath 3D math library development files
 Kazmath is a 3D math library written in C.
 .
 This package contains the files needed to compile and link programs which
 use Kazmath.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules file - for GNU Hello.
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified

package = libkazmath-dev
docdir = debian/tmp/usr/share/doc/$(package)

CC = gcc
CFLAGS = -g -Wall
INSTALL_PROGRAM = install

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

build:
	$(checkdir)
	cmake -DCMAKE_INSTALL_PREFIX=/usr .
	$(MAKE) CC="$(CC)" CFLAGS="$(CFLAGS)"
	touch build

clean:
	$(checkdir)
	rm -f build
	cmake -DCMAKE_INSTALL_PREFIX=/usr .
	[ ! -f Makefile ] || $(MAKE) clean
	rm -r *.cmake Makefile CMakeFiles CMakeCache.txt
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars

binary-indep:   checkroot build
	$(checkdir)
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch:    checkroot build
	$(checkdir)
	rm -rf debian/tmp
	install -d debian/tmp/DEBIAN $(docdir)
	#install -m 755 debian/postinst debian/prerm debian/tmp/DEBIAN
	#$(MAKE) INSTALL_PROGRAM="$(INSTALL_PROGRAM)" \
	#		prefix=$$(pwd)/debian/tmp/usr install
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp $(INSTALL_PROGRAM)
	cp -a debian/copyright $(docdir)
	cp -a debian/changelog $(docdir)/changelog.Debian
	cp -a ChangeLog $(docdir)/changelog
	cd $(docdir) && gzip -9 changelog changelog.Debian
	#dpkg-shlibdeps debian/tmp/usr/bin/hello
	dpkg-gencontrol -isp
	chown -R root:root debian/tmp
	chmod -R u+w,go=rX debian/tmp
	dpkg --build debian/tmp ..

define checkdir
	test -f CMakeLists.txt -a -f debian/rules
endef

binary: binary-indep binary-arch

checkroot:
	$(checkdir)
	test $$(id -u) = 0

.PHONY: binary binary-arch binary-indep clean checkroot
